// PPService.h: interface for the CPPService class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PPSERVICE_H__7545C05C_B9EE_4F3A_8549_64B85A2DFF77__INCLUDED_)
#define AFX_PPSERVICE_H__7545C05C_B9EE_4F3A_8549_64B85A2DFF77__INCLUDED_

#include <string>
using namespace std;

class Point
{
public:
	int x;
	int y;
	Point();
	~Point();
};

typedef struct PointArrayTag
{
	Point* m_Array;
	int m_Size;
} PointArray;

class Triangle
{
public:
	Point* p1;
	Point* p2;
	Point* p3;
	Triangle();
	~Triangle();
};

typedef struct TriangleArrayTag
{
	Triangle* m_Array;
	int m_Size;
} TriangleArray;

class Polygon
{
public:
	string name;
	PointArray points;
	Polygon();
	~Polygon();
};

class CPPService  
{
public:
	double Distance(Point* p1, Point* p2);
	Point* AddPoint(Point* p1, Point* p2);
	//Array Variables always passed and returned by value.	
	PointArray EchoPointArray(PointArray Array); 
	Polygon* EchoPolygon(Polygon* p);
	int Add(int a, int b);
	double Perimeter(const Triangle* pTri);

	CPPService();
	virtual ~CPPService();
};

#endif // !defined(AFX_PPSERVICE_H__7545C05C_B9EE_4F3A_8549_64B85A2DFF77__INCLUDED_)
