/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "SOAP" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 *
 *
 *
 * @author  Damitha Kumarage (damitha@opensource.lk, damitha@jkcsworld.com)
 *
 */

#include "LogHandler.h"
//#include <axis/common/AxisTrace.h>
#include <axis/common/AxisException.h>
#include <time.h>
#include <stdio.h>
#include <string>

#define linesize 100
using namespace std;

LogHandler::LogHandler()
{
  m_pOption = NULL;
  m_sEmpty = "";

}

LogHandler::~LogHandler()
{

}
// Implementation of BasicHandler interface.
int LogHandler::Invoke(IMessageData* md)
{
    //AXISTRACE1("LogHandler::Invoke(IMessageData* md)");
    AXIS_TRY

    char line[linesize] = {0};
    char printcount[linesize] = {0};
    string s = "logAccessCountFile";
    string sFileName = GetOption(s);
    //AXISTRACE2("sFileName", sFileName.c_str());
    if(!sFileName.empty())
    {
        //AXISTRACE1("file name not empty");
        if ((fileLogCount = fopen(sFileName.c_str(), "at")) == NULL)
            return AXIS_FAIL;
        int nLineCount = 0;
        //AXISTRACE1("file opened for read");
        while(fgets(line, linesize, fileLogCount) != NULL)
        {   
            nLineCount++;
        }
        nLineCount = nLineCount/2;
        nLineCount++;
        fclose(fileLogCount);
        
        if ((fileLogCount = fopen(sFileName.c_str(), "a")) == NULL)
            return AXIS_FAIL;
        else
        {
            //AXISTRACE1("file opened for write");
            time_t ltime;
            time(&ltime);

            fputs("time : ", fileLogCount);
            fputs(ctime(&ltime), fileLogCount);
            fputs(": service ", fileLogCount);
            fputs("Service ", fileLogCount);
            //AXISTRACE1("came here2");
            fputs(" is accessed ", fileLogCount);
            sprintf(printcount,"%d", nLineCount);
            fputs(printcount, fileLogCount);      
            fputs(" times.\n", fileLogCount);
        }
        fclose(fileLogCount);
        
        //AXISTRACE1("LogHandler Invoke end");
      
        return AXIS_SUCCESS;     
    }
    else
    {
      return AXIS_FAIL;
    }
    AXIS_CATCH(...)
        return AXIS_FAIL;
    AXIS_ENDCATCH
}

void LogHandler::OnFault(IMessageData* mc)
{

}

const string& LogHandler::GetOption(const string& sArg)
{
	map<string, string>::const_iterator it = m_pOption->find(sArg.c_str());
	if (it != m_pOption->end())
	{
		return (*it).second;
	}
	return m_sEmpty;
}

void LogHandler::SetOptionList(const map<string, string>* OptionList)
{
   m_pOption = OptionList;
}

int LogHandler::Init()
{
	//do any initialization, resetting of values

	return AXIS_SUCCESS;
}

int LogHandler::Fini()
{
	//do any finalizatoin

	return AXIS_SUCCESS;
}
